SystemOrganization addCategory: #'Limbo-Core'!
SystemOrganization addCategory: 'Limbo-Core-Exceptions'!

NBExternalObject subclass: #LimboFunction
	instanceVariableNames: 'exitStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

LimboFunction subclass: #LimboDup2
	instanceVariableNames: 'target source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboDup2 class methodsFor: 'instance creation' stamp: 'MML 11/23/2012 11:16'!
redirect: fd1 to: fd2
	^ self basicNew
		initialize;
		target: fd1;
		source: fd2;
		run;
		yourself! !

!LimboDup2 methodsFor: 'primitives' stamp: 'MML 11/23/2012 11:13'!
primitiveRun: fd1 source: fd2
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int dup2(int fd1, int fd2) )! !

!LimboDup2 methodsFor: 'running' stamp: 'MML 11/23/2012 11:12'!
run
	| fd |
	fd := self primitiveRun: self target source: self source.
	self exitStatus: (fd = -1
		ifTrue: [ -1 ]
		ifFalse: [ 0 ])! !

!LimboDup2 methodsFor: 'accessing' stamp: 'MML 11/23/2012 11:16'!
source
	^ source! !

!LimboDup2 methodsFor: 'accessing' stamp: 'MML 11/23/2012 11:16'!
source: anInteger
	source := anInteger! !

!LimboDup2 methodsFor: 'accessing' stamp: 'MML 11/23/2012 11:16'!
target
	^ target! !

!LimboDup2 methodsFor: 'accessing' stamp: 'MML 11/23/2012 11:15'!
target: anInteger
	target := anInteger! !

LimboFunction subclass: #LimboFStat
	instanceVariableNames: 'statStructPointer fileDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboFStat class methodsFor: 'instance creation' stamp: 'MML 11/23/2012 10:45'!
stat: aFileDescriptor
	^ self basicNew
		initialize;
		fileDescriptor: aFileDescriptor;
		run;
		yourself! !

!LimboFStat methodsFor: 'accessing' stamp: 'MML 11/23/2012 10:47'!
fileDescriptor
	^ fileDescriptor! !

!LimboFStat methodsFor: 'accessing' stamp: 'MML 11/23/2012 10:47'!
fileDescriptor: anInteger
	fileDescriptor := anInteger! !

!LimboFStat methodsFor: 'accessing' stamp: 'MML 11/23/2012 10:52'!
free
	statStructPointer free.
	statStructPointer := nil! !

!LimboFStat methodsFor: 'primitives' stamp: 'MML 11/23/2012 10:48'!
primitiveRun: fd statStruct: struct
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int fstat(int fd, NBExternalAddress struct) )! !

!LimboFStat methodsFor: 'running' stamp: 'MML 11/23/2012 10:43'!
run
	self exitStatus: (self primitiveRun: self fileDescriptor statStruct: self statStructPointer)! !

!LimboFStat methodsFor: 'accessing' stamp: 'MML 11/23/2012 10:51'!
statStruct
	^ LimboStatStruct fromPointer: self statStructPointer! !

!LimboFStat methodsFor: 'accessing' stamp: 'MML 11/23/2012 10:43'!
statStructPointer
	^ statStructPointer ifNil: [ statStructPointer := NativeBoost allocate: LimboStatStruct instanceSize ]! !

LimboFunction subclass: #LimboFork
	instanceVariableNames: 'childProcessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboFork methodsFor: 'primitives' stamp: 'MML 11/22/2012 16:58'!
primitiveExecv: command arguments: pointer
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int execv(String command, NBExternalAddress pointer) )	! !

!LimboFork methodsFor: 'primitives' stamp: 'MML 11/22/2012 16:05'!
primitiveRun
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int fork() )! !

!LimboFork methodsFor: 'running' stamp: 'MML 11/23/2012 14:10'!
run
	childProcessId := self primitiveRun.
	self exitStatus: (childProcessId = -1
		ifTrue: [ -1 ]
		ifFalse: [ 0 ])! !

!LimboFunction class methodsFor: 'instance creation' stamp: 'MML 11/22/2012 16:08'!
new
	^ self basicNew
		initialize;
		run;
		yourself! !

!LimboFunction methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:35'!
exitStatus
	^ exitStatus! !

!LimboFunction methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:35'!
exitStatus: anInteger
	exitStatus := anInteger! !

!LimboFunction methodsFor: 'as yet unclassified' stamp: 'MML 11/21/2012 14:33'!
nbLibraryNameOrHandle 
	^ NativeBoost CLibrary! !

LimboFunction subclass: #LimboKill
	instanceVariableNames: 'processId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboKill class methodsFor: 'instance creation' stamp: 'MML 11/23/2012 14:04'!
kill: aProcessId
	^ self basicNew
		initialize;
		processId: aProcessId;
		run;
		yourself! !

!LimboKill methodsFor: 'primitives' stamp: 'MML 11/23/2012 14:06'!
primitiveRun: aProcessId signal: aSignal
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int kill(int aProcessId, int aSignal) )! !

!LimboKill methodsFor: 'accessing' stamp: 'MML 11/23/2012 14:06'!
processId
	^ processId! !

!LimboKill methodsFor: 'accessing' stamp: 'MML 11/23/2012 14:07'!
processId: aProcessId
	processId := aProcessId! !

!LimboKill methodsFor: 'running' stamp: 'MML 11/23/2012 14:05'!
run
	self exitStatus: (self primitiveRun: self processId signal: 9)! !

LimboFunction subclass: #LimboPipe
	instanceVariableNames: 'readFileDescriptor writeFileDescriptor readFDPointer writeFDPointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboPipe class methodsFor: 'as yet unclassified' stamp: 'MML 11/21/2012 14:55'!
finalizeResourceData: aPipe
	aPipe
		closeReadEnd;
		closeWriteEnd! !

!LimboPipe methodsFor: 'operations' stamp: 'MML 11/21/2012 14:48'!
closeReadEnd
	self exitStatus: (self primitiveClose: self readFileDescriptor)! !

!LimboPipe methodsFor: 'operations' stamp: 'MML 11/21/2012 14:48'!
closeWriteEnd
	self exitStatus: (self primitiveClose: self writeFileDescriptor)! !

!LimboPipe methodsFor: 'cleanup' stamp: 'MML 11/21/2012 14:43'!
free
	"allocated 8 bytes with readFDPointer. Freeing that pointer will free 8 bytes and therefore writeFDPointer need not be freed"
	readFDPointer free.
	readFDPointer := nil.
	writeFDPointer := nil! !

!LimboPipe methodsFor: 'initialization' stamp: 'MML 11/21/2012 15:00'!
initialize
	super initialize.
	
	self readFDPointer: (NativeBoost allocate: 8).
	self writeFDPointer: (NBExternalAddress value: self readFDPointer value + 4).
	
	NBExternalResourceManager 
		addResource: self
		data: self! !

!LimboPipe methodsFor: 'primitives' stamp: 'MML 11/21/2012 14:48'!
primitiveClose: anInteger
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int close(int anInteger) )! !

!LimboPipe methodsFor: 'primitives' stamp: 'MML 11/22/2012 17:49'!
primitiveReadInto: bufferPointer fileDescriptor: fd size: size
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int read(int fd, NBExternalAddress bufferPointer, int size) )! !

!LimboPipe methodsFor: 'primitives' stamp: 'MML 11/21/2012 14:14'!
primitiveRun: pipePointer
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int pipe(NBExternalAddress pipePointer) )! !

!LimboPipe methodsFor: 'primitives' stamp: 'MML 11/22/2012 17:38'!
primitiveWrite: aString fileDescriptor: fd size: size
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int  write(int fd, String aString, int size) )! !

!LimboPipe methodsFor: 'operations' stamp: 'MML 11/23/2012 13:40'!
read: length
	| bytesRead buffer string |
	buffer := NativeBoost allocate: length + 1.
	bytesRead := (self primitiveReadInto: buffer fileDescriptor: self readFileDescriptor size: length + 1).
	self exitStatus: (bytesRead = length
		ifTrue: [ 0 ]
		ifFalse: [ -1 ]).
	buffer byteAt: length put: 0. "0 terminate"
	string := buffer readString.
	buffer free.
	^ string! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:27'!
readFDPointer
	^ readFDPointer! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:26'!
readFDPointer: aPointer
	readFDPointer := aPointer! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:16'!
readFileDescriptor
	^ readFileDescriptor! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:30'!
readFileDescriptor: anInteger
	readFileDescriptor := anInteger! !

!LimboPipe methodsFor: 'running' stamp: 'MML 11/21/2012 14:31'!
readFileDescriptors
	self 
		readFileDescriptor: (self readFDPointer nbUInt32AtOffset: 0);
		writeFileDescriptor: (self writeFDPointer nbUInt32AtOffset: 0).
		
	self free! !

!LimboPipe methodsFor: 'running' stamp: 'MML 11/21/2012 14:29'!
run
	self exitStatus: (self primitiveRun: self readFDPointer).
	self readFileDescriptors! !

!LimboPipe methodsFor: 'operations' stamp: 'MML 11/22/2012 18:06'!
write: aString
	| bytesWritten terminatedString |
	terminatedString := aString copyWith: (Character value: 0).
	
	bytesWritten := (self primitiveWrite: terminatedString fileDescriptor: self writeFileDescriptor size: terminatedString size).
	self exitStatus: (bytesWritten = (terminatedString size)
		ifTrue: [ 0 ]
		ifFalse: [ -1 ])! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:27'!
writeFDPointer
	^ writeFDPointer! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:27'!
writeFDPointer: aPointer
	writeFDPointer := aPointer! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:16'!
writeFileDescriptor
	^ writeFileDescriptor! !

!LimboPipe methodsFor: 'accessing' stamp: 'MML 11/21/2012 14:31'!
writeFileDescriptor: anInteger
	writeFileDescriptor := anInteger! !

LimboFunction subclass: #LimboWait
	instanceVariableNames: 'processId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboWait class methodsFor: 'instance creation' stamp: 'MML 11/23/2012 14:46'!
waitFor: aProcessId
	^ self basicNew
		initialize;
		processId: aProcessId;
		run;
		yourself! !

!LimboWait methodsFor: 'primitives' stamp: 'MML 11/23/2012 14:55'!
primitiveRun: aProcessId statusPointer: statusPointer options: optionBits
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( int waitpid(int aProcessId, NBExternalAddress statusPointer, int optionBits) )! !

!LimboWait methodsFor: 'accessing' stamp: 'MML 11/23/2012 14:57'!
processId
	^ processId! !

!LimboWait methodsFor: 'accessing' stamp: 'MML 11/23/2012 14:58'!
processId: aProcessId
	processId := aProcessId! !

!LimboWait methodsFor: 'running' stamp: 'MML 11/23/2012 14:58'!
run
	| pid statusPointer |
	statusPointer := NativeBoost allocate: 4.
	pid := self primitiveRun: self processId statusPointer: statusPointer options: 0.
	statusPointer free.
	self exitStatus: (pid = -1
		ifTrue: [ -1 ]
		ifFalse: [ 0 ]).! !

NBExternalStructure subclass: #LimboStatStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboStatStruct commentStamp: 'MML 11/22/2012 16:16' prior: 0!
struct stat {
	dev_t	 	st_dev;		/* [XSI] ID of device containing file */
	ino_t	  	st_ino;		/* [XSI] File serial number */
	mode_t	 	st_mode;	/* [XSI] Mode of file (see below) */
	nlink_t		st_nlink;	/* [XSI] Number of hard links */
	uid_t		st_uid;		/* [XSI] User ID of the file */
	gid_t		st_gid;		/* [XSI] Group ID of the file */
	dev_t		st_rdev;	/* [XSI] Device ID */
#if !!defined(_POSIX_C_SOURCE) || defined(_DARWIN_C_SOURCE)
	struct	timespec st_atimespec;	/* time of last access */
	struct	timespec st_mtimespec;	/* time of last data modification */
	struct	timespec st_ctimespec;	/* time of last status change */
#else
	time_t		st_atime;	/* [XSI] Time of last access */
	long		st_atimensec;	/* nsec of last access */
	time_t		st_mtime;	/* [XSI] Last data modification time */
	long		st_mtimensec;	/* last data modification nsec */
	time_t		st_ctime;	/* [XSI] Time of last status change */
	long		st_ctimensec;	/* nsec of last status change */
#endif
	off_t		st_size;	/* [XSI] file size, in bytes */
	blkcnt_t	st_blocks;	/* [XSI] blocks allocated for file */
	blksize_t	st_blksize;	/* [XSI] optimal blocksize for I/O */
	__uint32_t	st_flags;	/* user defined flags for file */
	__uint32_t	st_gen;		/* file generation number */
	__int32_t	st_lspare;	/* RESERVED: DO NOT USE!! */
	__int64_t	st_qspare[2];	/* RESERVED: DO NOT USE!! */
};
!

!LimboStatStruct class methodsFor: 'fields description' stamp: 'MML 11/22/2012 16:41'!
fieldsDesc
	 ^ #(
			int	 					st_dev;
			ulong	  				st_ino;
			ushort	 				st_mode;
			ushort					st_nlink;
			uint						st_uid;
			uint						st_gid;
			int						st_rdev;
			LimboTimespecStruct 	st_atimespec;
			LimboTimespecStruct 	st_mtimespec;
			LimboTimespecStruct 	st_ctimespec;
			longlong				st_size;
			longlong 				st_blocks;
			int						st_blksize;
			uint						st_flags;
			uint						st_gen;
			int						st_lspare;
			longlong				*st_qspare "st_qspare[]"
		)! !

NBExternalStructure subclass: #LimboTimespecStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboTimespecStruct commentStamp: 'MML 11/22/2012 16:44' prior: 0!
_STRUCT_TIMESPEC
{
	__darwin_time_t	tv_sec;
	long		tv_nsec;
};
!

!LimboTimespecStruct class methodsFor: 'fields description' stamp: 'MML 11/22/2012 16:44'!
fieldsDesc
	 ^ #(
			long	tv_sec;
			long	tv_nsec;
		)! !

Error subclass: #LimboError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core-Exceptions'!

Object subclass: #Limbo
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 18:55'!
run: aString arguments: aCollection
	^ self new
		run: aString arguments: aCollection;
		yourself! !

!Limbo class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:02'!
runSh: aString
	^ self new
		runSh: aString;
		yourself! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:47'!
command
	^ command ifNil: [ command := LimboCommand new ]! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
command: aLimboCommand
	command := aLimboCommand! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
errorString
	^ self command errorString! !

!Limbo methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:43'!
outString
	^ self command outString! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:46'!
run: aString arguments: aCollection
	self command
		command: aString;
		arguments: aCollection;
		run! !

!Limbo methodsFor: 'running' stamp: 'MML 11/14/2012 18:32'!
runSh: aString
	self run: '/bin/sh' arguments: { '-c'. aString }! !

!Limbo methodsFor: 'testing' stamp: 'MML 11/19/2012 18:52'!
succeeded
	^ self command exitStatus isZero! !

Object subclass: #LimboCommand
	instanceVariableNames: 'command arguments outString errorString pointers exitStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Limbo-Core'!

!LimboCommand class methodsFor: 'instance creation' stamp: 'MML 11/14/2012 17:15'!
command: aString arguments: aCollection
	^ self new
		command: aString;
		arguments: aCollection;
		yourself! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:12'!
arguments
	^ arguments! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/19/2012 18:57'!
arguments: aCollection
	aCollection isString ifTrue: [ LimboError signal: 'expected collection of strings.' ].
	
	arguments := aCollection! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command
	^ command! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 17:11'!
command: aString
	command := aString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString
	^ errorString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
errorString: aString
	errorString := aString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/15/2012 16:37'!
exitStatus
	^ exitStatus! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/15/2012 16:37'!
exitStatus: aNumber
	exitStatus := aNumber! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:54'!
freePointers
	self pointers do: [ :pointer | pointer free ].
	pointers := nil! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:54'!
integerPointer
	| pointer |
	pointer := NativeBoost allocate: 4.
	self registerPointer: pointer.
	^ pointer! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/19/2012 19:08'!
nbLibraryNameOrHandle
	^ 'liblimbo.dylib'! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString
	^ outString! !

!LimboCommand methodsFor: 'accessing' stamp: 'MML 11/14/2012 18:42'!
outString: aString
	outString := aString! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/15/2012 09:12'!
pointers
	^ pointers ifNil: [ pointers := Set new ]! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:54'!
primitiveArguments
	| bufferPointer |
	bufferPointer := NativeBoost allocate: self primitiveShellArguments size * 4.
	self registerPointer: bufferPointer.
	self primitiveCollectArgumentPointersInto: bufferPointer.
	
	 ^ bufferPointer! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:54'!
primitiveBufferFrom: aPointer at: anIndex
	| pointer string |
	pointer := NBExternalAddress new.
	self registerPointer: pointer.
	pointer value: (aPointer nbUInt32AtOffset: anIndex).
	string := pointer readString.
		
	^ string! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:55'!
primitiveCollectArgumentPointersInto: aPointer
	self primitiveShellArguments allButLast withIndexDo: [ :string :index || pointer | "0 terminated"
		pointer := NativeBoost allocate: string size + 1.
		self registerPointer: pointer.
		NativeBoost memCopy: string to: pointer size: string size.
		pointer nbUInt8AtOffset: string size put: 0. "string terminating null char"
		aPointer nbUInt32AtOffset: (index - 1) * 4 put: pointer value ].
	
	aPointer nbUInt32AtOffset: (self primitiveShellArguments size - 1) * 4 put: 0! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveErrorPointerIndex
	^ 4! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 17:30'!
primitiveOutPointerIndex
	^ 0! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 10:58'!
primitiveReadOut: outBuffer outLength: outLength error: errorBuffer errorLength: errorLength
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( int read_buffers (NBExternalAddress outBuffer, int outLength, NBExternalAddress errorBuffer, int errorLength) ) ! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/22/2012 17:55'!
primitiveReadStringsOutLength: outLenghtPointer errorLength: errorLengthPointer
	| outLength errorLength outBuffer errorBuffer |
	outLength := outLenghtPointer nbUInt32AtOffset: 0.
	errorLength := errorLengthPointer nbUInt32AtOffset: 0.
	outBuffer := NativeBoost allocate: outLength + 1.
	self registerPointer: outBuffer.
	errorBuffer := NativeBoost allocate: errorLength + 1.
	self registerPointer: errorBuffer.
	
	self 
		primitiveReadOut: outBuffer 
		outLength: outLength 
		error: errorBuffer
		errorLength: errorLength.
		
	self 
		outString: outBuffer readString;
		errorString: errorBuffer readString! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 16:36'!
primitiveRun
	| outLength errorLength |
	outLength := self integerPointer.
	errorLength := self integerPointer.
	self exitStatus: 
		(self 
			primitiveRun: self primitiveArguments
			outLength: outLength
			errorLength: errorLength).
		
	self exitStatus isNumber ifFalse: [ LimboError signal: 'Something went wrong when calling a NB primitive' ].
	
	self primitiveReadStringsOutLength: outLength errorLength: errorLength! !

!LimboCommand methodsFor: 'private-primitives' stamp: 'MML 11/15/2012 10:56'!
primitiveRun: argPointer outLength: outLengthPointer errorLength: errorLengthPointer
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( int run_command (NBExternalAddress argPointer, NBExternalAddress outLengthPointer, NBExternalAddress errorLengthPointer) ) ! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/14/2012 18:05'!
primitiveShellArguments
	^ OrderedCollection new
		add: self command;
		addAll: self arguments;
		add: 0; "shell arguments are '\0' terminated"
		yourself! !

!LimboCommand methodsFor: 'printing' stamp: 'MML 11/14/2012 17:14'!
printCommand
	String streamContents: [ :stream |
		stream nextPutAll: self command.
		self arguments do: [ :string |
			stream 
				space;
				nextPutAll: string ] ]! !

!LimboCommand methodsFor: 'private-accessing' stamp: 'MML 11/15/2012 09:11'!
registerPointer: aPointer
	self pointers add: aPointer! !

!LimboCommand methodsFor: 'running' stamp: 'MML 11/15/2012 09:16'!
run
	[ self primitiveRun ] ensure: [ self freePointers ]! !
